4 / 0ZeroDivisionError: integer division or modulo by zeroЯ хочу отформатировать его в:ZeroDivisonError, tmp.py, 1" />
Вопрос:

Python Когда я ловлю исключение, как я могу получить тип, файл и номер строки?

python exception exception-handling stack-trace

192486 просмотра

4 ответа

134493 Репутация автора

Поймать исключение, которое будет печататься так:

Traceback (most recent call last):
  File "c:/tmp.py", line 1, in <module>
    4 / 0
ZeroDivisionError: integer division or modulo by zero

Я хочу отформатировать его в:

ZeroDivisonError, tmp.py, 1
Автор: Claudiu Источник Размещён: 14.08.2009 04:02

Ответы (4)


335 плюса

42450 Репутация автора

Решение
import sys, os

try:
    raise NotImplementedError("No error")
except Exception as e:
    exc_type, exc_obj, exc_tb = sys.exc_info()
    fname = os.path.split(exc_tb.tb_frame.f_code.co_filename)[1]
    print(exc_type, fname, exc_tb.tb_lineno)
Автор: Ants Aasma Размещён: 14.08.2009 04:09

45 плюса

1441 Репутация автора

Источник (Py v2.7.3) для traceback.format_exception () и вызванных / связанных функций очень помогает. Смущающе, я всегда забываю прочитать источник . Я сделал это только после тщательного поиска похожих деталей. Простой вопрос: «Как воссоздать тот же вывод, что и Python для исключения, со всеми теми же деталями?» Это получит кого-нибудь на 90 +% к тому, что они ищут. Разочарованный, я придумал этот пример. Я надеюсь, что это помогает другим. (Это точно помогло мне; ;-)

import sys, traceback

traceback_template = '''Traceback (most recent call last):
  File "%(filename)s", line %(lineno)s, in %(name)s
%(type)s: %(message)s\n''' # Skipping the "actual line" item

# Also note: we don't walk all the way through the frame stack in this example
# see hg.python.org/cpython/file/8dffb76faacc/Lib/traceback.py#l280
# (Imagine if the 1/0, below, were replaced by a call to test() which did 1/0.)

try:
    1/0
except:
    # http://docs.python.org/2/library/sys.html#sys.exc_info
    exc_type, exc_value, exc_traceback = sys.exc_info() # most recent (if any) by default

    '''
    Reason this _can_ be bad: If an (unhandled) exception happens AFTER this,
    or if we do not delete the labels on (not much) older versions of Py, the
    reference we created can linger.

    traceback.format_exc/print_exc do this very thing, BUT note this creates a
    temp scope within the function.
    '''

    traceback_details = {
                         'filename': exc_traceback.tb_frame.f_code.co_filename,
                         'lineno'  : exc_traceback.tb_lineno,
                         'name'    : exc_traceback.tb_frame.f_code.co_name,
                         'type'    : exc_type.__name__,
                         'message' : exc_value.message, # or see traceback._some_str()
                        }

    del(exc_type, exc_value, exc_traceback) # So we don't leave our local labels/objects dangling
    # This still isn't "completely safe", though!
    # "Best (recommended) practice: replace all exc_type, exc_value, exc_traceback
    # with sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2]

    print
    print traceback.format_exc()
    print
    print traceback_template % traceback_details
    print

В конкретном ответе на этот запрос:

sys.exc_info()[0].__name__, os.path.basename(sys.exc_info()[2].tb_frame.f_code.co_filename), sys.exc_info()[2].tb_lineno
Автор: pythonlarry Размещён: 16.04.2013 08:55

30 плюса

2422 Репутация автора

Вот пример показа номера строки, где происходит исключение.

import sys
try:
    print(5/0)
except Exception as e:
    print('Error on line {}'.format(sys.exc_info()[-1].tb_lineno), type(e).__name__, e)

print('And the rest of program continues')
Автор: Stryker Размещён: 13.01.2017 07:29

80 плюса

4524 Репутация автора

Самая простая форма, которая работала для меня.

import traceback

try:
    print(4/0)
except ZeroDivisionError:
    print(traceback.format_exc())

Выход

Traceback (most recent call last):
  File "/path/to/file.py", line 51, in <module>
    print(4/0)
ZeroDivisionError: division by zero

Process finished with exit code 0
Автор: nu everest Размещён: 05.12.2017 05:10
Вопросы из категории :
32x32